rem ========================================================
rem  061027a.bas, by tenasaku (Oct 27, 2006)
rem ========================================================
rem  bifurcation and disappearance of the attractor for 
rem  interval dynamical systems
rem     f(x) = lambda*x*(1-x)  [ 2.5 <= lambda <= 4.0 ]
rem ========================================================

rem If the program goes too slowly, lower the following values.
numpts = 200: '    number of samples for each value of the parameter
iteration = 500: ' number of iterations for each sample

rem -- Size of the graphics window --
winwd = 961: ' width of the window
winht = 641: ' height of the window
rem If we fail to open the graphics window, the reason should be
rem that the attempted window size is too big.  Then try e.g. 
rem    winwd = 481
rem    winht = 321
rem Note: winht should be (winwd-1)*2/3+1

rem -- Check if we have enough memory to open the window --
maxwinwd = graphics (-38): ' maximum of window width
maxwinht = graphics (-39): ' maxmum of window height
rem maxpxldp = graphics (-34): ' pixel depth
if (maxwinwd < winwd) or (maxwinht < winht)
  graphics -1
  print "Oops, I cannot open the graphics window..."
  stop
end if

rem -- open the main window and name it --
graphics 0: graphics window 0,24,winwd,winht
macfunction ("wintitle", "MY PROGRAM")
clearWindow(0)
graphics color 0,100,100

for m = 0 to winwd-1
  lambda = 2.5+m/(winwd-1)*1.5
  for n = 1 to numpts
    x = rnd(1000)/1000
    countdown = iteration
    while (countdown > 0)
      countdown = countdown - 1
      x = lambda*x*(1 - x)
    wend
    graphics pset m,winht - 1 - int(x*(winht - 1))
  next n
next m
beep(0)
end

rem -- subroutines --
sub clearWindow(dummy)
  graphics color 0, 0, 0
  graphics fillrect 0, 0, winwd - 1, winht - 1
end sub

sub beep(dummy)
  sound 884, 0.1, 20: sound 663, 0.1, 20: sound 442, 0.1, 20
end sub

rem =============================
rem  RegExps for Syntax Coloring
rem =============================
rem reserved words for math operations
rem (\b(mod|and|or|xor|not)\b)|[\+\-\^\/\*]|\>|\<|(\>\=)|(\<\=)|(\<\>)|\=

rem reserved words for built in functions
rem (\b(sqr|log|exp|sin|cos|tan|atn|pi|abs|sgn|int|rnd|peek|val|asc|len|random|lof|loc|get|put|eof|fgetbyte|fseek|fputbyte|timer|sound|morse|say|doevents|inputbox|home|cls|gotoxy|htab|vtab|pos|menu|mouse|varptr|peek|poke|fre|push|pop|isarray|asin|acos|sinh|cosh|tanh|log10|floor|true|false|ubound|macfunction)\b)|(\b(mid|right|left|str|chr|lcase|ucase|field|inkey|input|date|time)\$)

rem reserved words for OOP
rem \b(type|class|extends|string|integer|single|double|longint)\b

rem reserved words for program syntax
rem \b(end|goto|if|then|else|endif|gosub|return|for|to|step|next|while|wend|select|case|sub|call|let|dim|erase|data|def\s+fn|mat|usr|exec|and|or|xor|not|mod)\b

rem reserved words for execution
rem \b(run|stop|exit|quit|cont|renum|new|clear|list|files|dir)\b

rem reserved words for I/O
rem \b(print|input|open|for\s+input|for\s+output|for\s+append|as|close\#?|load|save|read|restore|bload|bsave)\b

rem graphics command etc
rem \bgraphics\s+(window|pset|moveto|lineto|circle|oval|rect|filloval|fillrect|pensetup|color|triangle|pict|drawtext|textsetup|scrn)\b

rem reserved word future use? (according to quick-ref v.3.6.2(b6)
rem (\b(msgbox|do|loop|until|break|function|method|private|public|local|dialog|memstat|draw|play|min|max|each|redim|resume|static|option|degrees|radians|eqv|imp|key|is|set|width|swap)\b)|(\bfilename\$)